> ## Documentation Index
> Fetch the complete documentation index at: https://docs.trysoma.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# List providers

> List all available provider types that can be instantiated



## OpenAPI

````yaml api-reference/openapi.json get /api/bridge/v1/available-providers
openapi: 3.1.0
info:
  title: soma
  version: v1
servers: []
security: []
tags:
  - name: task
    description: >-
      Task management endpoints for creating, listing, and managing tasks and
      their messages
  - name: secret
    description: Secret management endpoints for storing and retrieving encrypted secrets
  - name: encryption
    description: >-
      Encryption key management endpoints for envelope keys, data encryption
      keys, and aliases
  - name: bridge
    description: >-
      Bridge endpoints for managing providers, credentials, functions, and MCP
      protocol communication
  - name: _internal
    description: >-
      Internal endpoints for health checks, runtime configuration, and SDK code
      generation
  - name: a2a
    description: >-
      Agent-to-agent communication endpoints for agent cards, definitions, and
      JSON-RPC requests
  - name: v1
    description: API version v1 endpoints
paths:
  /api/bridge/v1/available-providers:
    get:
      tags:
        - bridge
        - v1
      summary: List providers
      description: List all available provider types that can be instantiated
      operationId: list-available-providers
      parameters:
        - name: page_size
          in: query
          required: true
          schema:
            type: integer
            format: int64
          style: form
        - name: next_page_token
          in: query
          required: false
          schema:
            type: string
          style: form
      responses:
        '200':
          description: List available providers
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/ProviderControllerSerializedPaginatedResponse
        '400':
          description: Bad Request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error'
        '500':
          description: Internal Server Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error'
components:
  schemas:
    ProviderControllerSerializedPaginatedResponse:
      type: object
      required:
        - items
      properties:
        items:
          type: array
          items:
            $ref: '#/components/schemas/ProviderControllerSerialized'
        next_page_token:
          type: string
    Error:
      type: object
      required:
        - message
      properties:
        data: {}
        message:
          type: string
    ProviderControllerSerialized:
      type: object
      required:
        - type_id
        - name
        - categories
        - documentation
        - functions
        - credential_controllers
      properties:
        categories:
          type: array
          items:
            type: string
        credential_controllers:
          type: array
          items:
            $ref: '#/components/schemas/ProviderCredentialControllerSerialized'
        documentation:
          type: string
        functions:
          type: array
          items:
            $ref: '#/components/schemas/FunctionControllerSerialized'
        name:
          type: string
        type_id:
          type: string
    ProviderCredentialControllerSerialized:
      type: object
      required:
        - type_id
        - configuration_schema
        - name
        - documentation
        - requires_brokering
        - requires_resource_server_credential_refreshing
        - requires_user_credential_refreshing
      properties:
        configuration_schema:
          $ref: '#/components/schemas/ConfigurationSchema'
        documentation:
          type: string
        name:
          type: string
        requires_brokering:
          type: boolean
        requires_resource_server_credential_refreshing:
          type: boolean
        requires_user_credential_refreshing:
          type: boolean
        type_id:
          type: string
    FunctionControllerSerialized:
      type: object
      required:
        - type_id
        - name
        - documentation
        - parameters
        - output
        - categories
      properties:
        categories:
          type: array
          items:
            type: string
        documentation:
          type: string
        name:
          type: string
        output:
          $ref: '#/components/schemas/JsonSchema'
        parameters:
          $ref: '#/components/schemas/JsonSchema'
        type_id:
          type: string
    ConfigurationSchema:
      type: object
      required:
        - resource_server
        - user_credential
      properties:
        resource_server:
          $ref: '#/components/schemas/JsonSchema'
        user_credential:
          $ref: '#/components/schemas/JsonSchema'
    JsonSchema:
      type: object
      additionalProperties: true

````